config/routes.rb
Rails.application.routes.draw do
    root 'home#index'
    get "home", to: "home#index"

    resources :books, only: [:index, :show, :new, :create, :edit, :update, :destroy]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/book.rb
class Book < ApplicationRecord
    validates :title, :author, presence: true
    validates :pages_count, numericality: {only_integer: true, greater_than: 0}, allow_blank: true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    before_action :set_locale

    def default_url_options
        {locale: I18n.locale}
    end

    private

    def set_locale
        I18n.locale = params[:locale] || I18n.default_locale
        I18n.locale = locale
        cookies[:locale] = {value: locale, expires: 30.days}
    end
end

app/controllers/books_controller.rb
class BooksController < ApplicationController
    before_action :find_book, only: [:show, :edit, :update, :destroy]
    before_action :store_editor_name, only: [:create, :update]

    def index
        @books = Book.page(params[:page])
    end
    
    def show
    end

    def new
        @book = Book.new
    end

    def edit
    end

    def create
        
        @book = Book.new(book_params)
        if @book.save
            flash[:notice] = "Successfully created"
            redirect_to books_path
        else 
            render :new
        end
    end

    def update
        store_editor_name
        if @book.update(book_params)
            flash[:notice] = "Successfully updated"
            redirect_to books_path
        else
            render :edit
        end
    end

    def destroy
        @book.destroy
        flash[:alert] = "Successfully destroyed"
        redirect_to books_path
    end

    private

    def book_params
        params.require(:book).permit(:title, :author, :description, :pages_count, :published_at, :editor)
    end

    def find_book
        @book = Book.find(params[:id])
    end

    def store_editor_name
        session[:editor] = book_params[:editor]
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/books/_form.html.erb
<%= form_with model: @book, local: true do |form| %>
  <% if @book.errors.any? %>
    <h2>
      <%= pluralize(@book.errors.count, "error") %> prohibited this book from being saved:
    </h2>
    <ul>
      <% @book.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  <% end %>

  <p>
    <%= form.label :title %><br>
    <%= form.text_field :title %>
  </p>

  <p>
    <%= form.label :author %><br>
    <%= form.text_field :author %>
  </p>

  <p>
    <%= form.label :description %><br>
    <%= form.text_area :description %>
  </p>

  <p>
    <%= form.label :pages_count %><br>
    <%= form.number_field :pages_count %>
  </p>

  <p>
    <%= form.label :published_at %><br>
    <%= form.date_field :published_at %>
  </p>

    <p>
    <%= form.label :editor_name %><br>
    <%= form.text_field :editor, value: @book.editor || session[:editor] %>
  </p>

  <p>
    <%= form.submit %>
  </p>
<% end %>

<%= link_to"All the books", books_path %>

app/views/books/edit.html.erb
<h1>Edit the new book</h1>

<%= render "form" %>

app/views/books/index.html.erb
<h1>All the books</h1>

<table>
<tr>
<th></th>
<% @books.order(:title).each do |book| %>
<tr>
<td><%= book.title %></td>
<td><%= book.author%></td>
<td><%= book.description %></td>
<td><%= link_to "Show", book_path(book) %></td>
<td><%= link_to "Edit", edit_book_path(book) %></td>
<td><%= link_to 'Delete', book_path(book), method: :delete, data: { confirm: 'Are you sure?' } %></td>

</tr>
<% end %>
</tr>
</table>
<%= link_to "New book", new_book_path%>

app/views/books/new.html.erb
<h1>Create a new book</h1>

<%= render "form" %>

app/views/books/show.html.erb
<h1><%= @book.title%> </h1>
<p><strong> <%= @book.author%> - <%= @book.published_at%> - <%= @book.pages_count%> pages</p></strong>
<p><strong> <%= @book.description%></p></strong>

<%= link_to "New book", new_book_path%>
<%= link_to"All the books", books_path %>

app/views/home/index.html.erb
<div class="row">
    <div class="col-md-9">
        <h1>Home#index</h1>
    </div>
    <div class="col-md-3">
        <p><%= link_to "EN", url_for(only_path: true, locale: "en") %> - <%= link_to "FR", url_for(only_path: true, locale: "fr") %> </p>
    </div>
    <div class="row">
    <div class="col">
        <p><%= I18n.translate("home.index.welcome") %></p>
        <%= link_to"All the books", books_path %>
    </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Rent Books</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= favicon_link_tag 'icon.ico' %>
  </head>

  <body>
  <div class="container">
    <% flash.each do |name, msg| %>
        <%= content_tag :div, msg, class: name %>
    <% end %>

    <%= yield %>
    </div>
  </body>
</html>